
from pymtn_lib20 import *

def DevInit():
    print("控制器初始化开始")
    ''' 搜索控制器'''
    (devNum, devinfolist, ret) = pymtn.NMC_DevSearch(pymtn.TSearchMode.Internet)
    if ret != 0:
        print("控制器搜索出错,返回值为:", ret)
        exit()
    if ret == 0:
        print("the count of devices: (%s)" % (devNum))
        for i in range(0, devNum):
            print(devinfolist[i].address)
            print(devinfolist[i].idStr)
            print(devinfolist[i].description)
            print(devinfolist[i].ID)
    if devNum <= 0:
        print("没有找到控制器")
        exit()

    ''' 打开第一个控制器'''
    (devHandle, ret) = pymtn.NMC_DevOpenByID(devinfolist[0].idStr)
    if ret != pymtn.RTN_CMD_SUCCESS:
        print("控制器打开出错", ret)
        exit()

    # ''' 打开第一个控制器--只有一张卡的时候，直接打开，不用搜索'''
    # (devHandle, ret) = pymtn.NMC_DevOpen(0)
    # if ret != pymtn.RTN_CMD_SUCCESS:
    #     print("控制器打开出错", ret)
    #     exit()

    (Info, ret) = pymtn.NMC_GetCardInfo(devHandle)
    num = Info.axisNum
    axisHandle = [c_ushort(0)] * num
    for i in range(0, num):
        (axisHandle[i], ret) = pymtn.NMC_MtOpen(devHandle, i)
        if ret != pymtn.RTN_CMD_SUCCESS:
            print("控制器打开出错", ret)
            exit()

    print("控制器初始化结束")
    return (devHandle, axisHandle)

"""--------------------龙门--------------------"""
def Ext_GantryCom(devHandle, axisHandle):
    print("龙门 测试开始")
    # 设置龙门主动轴
    ret = pymtn.NMC_SetGantryMaster(axisHandle[0], 0)
    if ret != 0:
        print(f"设置龙门主动轴失败，错误码: {ret}")
    else:
        print("设置龙门主动轴成功")

    # 设置龙门从动轴
    ret = pymtn.NMC_SetGantrySlave(axisHandle[1], 0, 100)
    if ret != 0:
        print(f"设置龙门从动轴失败，错误码: {ret}")
    else:
        print("设置龙门从动轴成功")

    # 龙门功能关闭
    ret = pymtn.NMC_DelGantryGroup(axisHandle[0], 0)
    if ret != 0:
        print(f"关闭龙门功能失败，错误码: {ret}")
    else:
        print("关闭龙门功能成功")
    print("龙门 测试结束")
if __name__ == "__main__":
    devHandle, axisHandle = DevInit()
    Ext_GantryCom(devHandle, axisHandle[0])